###############
sub my_action {
###############

  #override with private functions?
  ##################################
    eval { &mylib_menue_snaps };                   # create this function in a private mylib.pl to replace this action

    my ($r,$p,$f,$ant,$l,@fs);

print <<EoF;
<pre><b>Clone a ZFS Filesystem from a snapshot</b>

A clone is a writable volume or file system whose initial contents are the same as the snapshot from which it was created.
Creating a clone is nearly instantaneous and initially consumes no additional disk space. In addition, you can snapshot a clone.

Clones can only be created from a snapshot. When a snapshot is cloned, an implicit dependency is created between the clone and snapshot.
Even though the clone is created somewhere else in the dataset hierarchy, the original snapshot cannot be destroyed as long as the clone exists.

The origin property exposes this dependency, and the zfs destroy command lists any such dependencies, if they exist.
Clones do not inherit the properties of the dataset from which it was created.

Because a clone initially shares all its disk space with the original snapshot, its used property value is initially zero.
As changes are made to the clone, it uses more disk space. The used property of the original snapshot does not include the disk space consumed by the clone.
Clones must be destroyed before the parent snapshot can be destroyed.


<b>Replacing a ZFS File System With a ZFS Clone</b>

You can use the zfs promote command to replace an active ZFS file system with a clone of that file system. This feature enables you to clone and replace
file systems so that the original file system becomes the clone of the specified file system. In addition, this feature makes it possible to destroy
the file system from which the clone was originally created. Without clone promotion, you cannot destroy an original file system of active clones.

</pre>
EoF

# header

# list clones
print "<script language='javascript'>\$('#hl').html('processing, please wait..')</script>\n";

print "<br><br><b>Current Filesystem Clones</b><br><br>";
$ant=&exe("zfs list -H -o name -t filesystem");
@fs=split(/\n/,$ant);

$l="Filesystem\tClone based on Snap\n";
$f="1";

foreach my $fs (@fs) {
     $r=&exe("zfs get -H -o value origin $fs");

     chomp ($r);
     if ($r=~/\@/) {

         # add creation
         $r=&exe("zfs get -H creation $r");
         $r=~s/ +/\t/gs;

         $l.="$fs\t$r\n";
         $f="0";
     }
}
if ($f) { $l.="none"; }
print &list2table($l);

print "<br><br><b>Current Volume Clones</b><br><br>";
$ant=&exe("zfs list -H -o name -t volume");
@fs=split(/\n/,$ant);

$l="Volume\tClone based on Snap\n";
$f="1";

foreach my $fs (@fs) {

     $r=&exe("zfs get -H -o value origin $fs");
print "$fs -> $r<br>";
     chomp ($r);
     if ($r=~/\@/) {

         # add creation
         $r=&exe("zfs get -H creation $r");
         $r=~s/ +/\t/gs;

         $l.="$fs\t$r\n";
         $f="0";
     }
}
if ($f) { $l.="none"; }
print &list2table($l);

print "<script language='javascript'>\$('#hl').html('Clone a snap and replace a filesystem with a clone on $in{'member'}')</script>\n";



} #/ my_action
##############
###############################################
#end of my script, do not delete the line below
1;
